# coding: utf-8

"""
    Twitter OpenAPI

    Twitter OpenAPI(Swagger) specification

    The version of the OpenAPI document: 0.0.1
    Contact: yuki@yuki0311.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist, constr, validator
from twitter_openapi_python_generated.models.additional_media_info import AdditionalMediaInfo
from twitter_openapi_python_generated.models.ext_media_availability import ExtMediaAvailability
from twitter_openapi_python_generated.models.media_original_info import MediaOriginalInfo
from twitter_openapi_python_generated.models.media_sizes import MediaSizes
from twitter_openapi_python_generated.models.media_stats import MediaStats
from twitter_openapi_python_generated.models.media_video_info import MediaVideoInfo

class MediaExtended(BaseModel):
    """
    MediaExtended
    """
    additional_media_info: Optional[AdditionalMediaInfo] = None
    display_url: StrictStr = Field(...)
    expanded_url: StrictStr = Field(...)
    ext_media_availability: ExtMediaAvailability = Field(...)
    features: Optional[Dict[str, Any]] = None
    id_str: constr(strict=True) = Field(...)
    indices: conlist(StrictInt) = Field(...)
    media_stats: Optional[MediaStats] = Field(None, alias="mediaStats")
    media_key: StrictStr = Field(...)
    media_url_https: StrictStr = Field(...)
    original_info: MediaOriginalInfo = Field(...)
    sizes: MediaSizes = Field(...)
    type: StrictStr = Field(...)
    url: StrictStr = Field(...)
    video_info: Optional[MediaVideoInfo] = None
    __properties = ["additional_media_info", "display_url", "expanded_url", "ext_media_availability", "features", "id_str", "indices", "mediaStats", "media_key", "media_url_https", "original_info", "sizes", "type", "url", "video_info"]

    @validator('id_str')
    def id_str_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[0-9]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9]+$/")
        return value

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('photo', 'video', 'animated_gif'):
            raise ValueError("must be one of enum values ('photo', 'video', 'animated_gif')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MediaExtended:
        """Create an instance of MediaExtended from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of additional_media_info
        if self.additional_media_info:
            _dict['additional_media_info'] = self.additional_media_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ext_media_availability
        if self.ext_media_availability:
            _dict['ext_media_availability'] = self.ext_media_availability.to_dict()
        # override the default output from pydantic by calling `to_dict()` of media_stats
        if self.media_stats:
            _dict['mediaStats'] = self.media_stats.to_dict()
        # override the default output from pydantic by calling `to_dict()` of original_info
        if self.original_info:
            _dict['original_info'] = self.original_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sizes
        if self.sizes:
            _dict['sizes'] = self.sizes.to_dict()
        # override the default output from pydantic by calling `to_dict()` of video_info
        if self.video_info:
            _dict['video_info'] = self.video_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MediaExtended:
        """Create an instance of MediaExtended from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MediaExtended.parse_obj(obj)

        _obj = MediaExtended.parse_obj({
            "additional_media_info": AdditionalMediaInfo.from_dict(obj.get("additional_media_info")) if obj.get("additional_media_info") is not None else None,
            "display_url": obj.get("display_url"),
            "expanded_url": obj.get("expanded_url"),
            "ext_media_availability": ExtMediaAvailability.from_dict(obj.get("ext_media_availability")) if obj.get("ext_media_availability") is not None else None,
            "features": obj.get("features"),
            "id_str": obj.get("id_str"),
            "indices": obj.get("indices"),
            "media_stats": MediaStats.from_dict(obj.get("mediaStats")) if obj.get("mediaStats") is not None else None,
            "media_key": obj.get("media_key"),
            "media_url_https": obj.get("media_url_https"),
            "original_info": MediaOriginalInfo.from_dict(obj.get("original_info")) if obj.get("original_info") is not None else None,
            "sizes": MediaSizes.from_dict(obj.get("sizes")) if obj.get("sizes") is not None else None,
            "type": obj.get("type"),
            "url": obj.get("url"),
            "video_info": MediaVideoInfo.from_dict(obj.get("video_info")) if obj.get("video_info") is not None else None
        })
        return _obj


