# coding: utf-8

"""
    Twitter OpenAPI

    Twitter OpenAPI(Swagger) specification

    The version of the OpenAPI document: 0.0.1
    Contact: yuki@yuki0311.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class TextEntityRef(BaseModel):
    """
    TextEntityRef
    """
    type: StrictStr = Field(...)
    url: StrictStr = Field(...)
    url_type: StrictStr = Field(..., alias="urlType")
    __properties = ["type", "url", "urlType"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('TimelineUrl'):
            raise ValueError("must be one of enum values ('TimelineUrl')")
        return value

    @validator('url_type')
    def url_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('ExternalUrl'):
            raise ValueError("must be one of enum values ('ExternalUrl')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TextEntityRef:
        """Create an instance of TextEntityRef from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TextEntityRef:
        """Create an instance of TextEntityRef from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TextEntityRef.parse_obj(obj)

        _obj = TextEntityRef.parse_obj({
            "type": obj.get("type"),
            "url": obj.get("url"),
            "url_type": obj.get("urlType")
        })
        return _obj


