# coding: utf-8

"""
    Twitter OpenAPI

    Twitter OpenAPI(Swagger) specification

    The version of the OpenAPI document: 0.0.1
    Contact: yuki@yuki0311.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictBool, conlist, constr, validator
from twitter_openapi_python_generated.models.tweet_edit_control_initial import TweetEditControlInitial

class TweetEditControl(BaseModel):
    """
    TweetEditControl
    """
    edit_control_initial: Optional[TweetEditControlInitial] = None
    edit_tweet_ids: Optional[conlist(constr(strict=True))] = None
    editable_until_msecs: Optional[constr(strict=True)] = None
    edits_remaining: Optional[constr(strict=True)] = None
    initial_tweet_id: Optional[constr(strict=True)] = None
    is_edit_eligible: Optional[StrictBool] = None
    __properties = ["edit_control_initial", "edit_tweet_ids", "editable_until_msecs", "edits_remaining", "initial_tweet_id", "is_edit_eligible"]

    @validator('editable_until_msecs')
    def editable_until_msecs_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9]+$/")
        return value

    @validator('edits_remaining')
    def edits_remaining_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9]+$/")
        return value

    @validator('initial_tweet_id')
    def initial_tweet_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9]+$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TweetEditControl:
        """Create an instance of TweetEditControl from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of edit_control_initial
        if self.edit_control_initial:
            _dict['edit_control_initial'] = self.edit_control_initial.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TweetEditControl:
        """Create an instance of TweetEditControl from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TweetEditControl.parse_obj(obj)

        _obj = TweetEditControl.parse_obj({
            "edit_control_initial": TweetEditControlInitial.from_dict(obj.get("edit_control_initial")) if obj.get("edit_control_initial") is not None else None,
            "edit_tweet_ids": obj.get("edit_tweet_ids"),
            "editable_until_msecs": obj.get("editable_until_msecs"),
            "edits_remaining": obj.get("edits_remaining"),
            "initial_tweet_id": obj.get("initial_tweet_id"),
            "is_edit_eligible": obj.get("is_edit_eligible")
        })
        return _obj


