# coding: utf-8

"""
    Twitter OpenAPI

    Twitter OpenAPI(Swagger) specification

    The version of the OpenAPI document: 0.0.1
    Contact: yuki@yuki0311.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from twitter_openapi_python_generated.models.user import User
from twitter_openapi_python_generated.models.user_unavailable import UserUnavailable
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

USERUNION_ONE_OF_SCHEMAS = ["User", "UserUnavailable"]

class UserUnion(BaseModel):
    """
    UserUnion
    """
    # data type: User
    oneof_schema_1_validator: Optional[User] = None
    # data type: UserUnavailable
    oneof_schema_2_validator: Optional[UserUnavailable] = None
    if TYPE_CHECKING:
        actual_instance: Union[User, UserUnavailable]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(USERUNION_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = UserUnion.construct()
        error_messages = []
        match = 0
        # validate data type: User
        if not isinstance(v, User):
            error_messages.append(f"Error! Input type `{type(v)}` is not `User`")
        else:
            match += 1
        # validate data type: UserUnavailable
        if not isinstance(v, UserUnavailable):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UserUnavailable`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in UserUnion with oneOf schemas: User, UserUnavailable. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in UserUnion with oneOf schemas: User, UserUnavailable. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> UserUnion:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> UserUnion:
        """Returns the object represented by the json string"""
        instance = UserUnion.construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("__typename")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `__typename` in the input.")

        # check if data type is `User`
        if _data_type == "User":
            instance.actual_instance = User.from_json(json_str)
            return instance

        # check if data type is `UserUnavailable`
        if _data_type == "UserUnavailable":
            instance.actual_instance = UserUnavailable.from_json(json_str)
            return instance

        # deserialize data into User
        try:
            instance.actual_instance = User.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UserUnavailable
        try:
            instance.actual_instance = UserUnavailable.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into UserUnion with oneOf schemas: User, UserUnavailable. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into UserUnion with oneOf schemas: User, UserUnavailable. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


